migrateできない

結論 python manage.py migrate --fakeで解決

python manage.py migrate リレーション"app_halls_hallmodel"はすでに存在します

myvenv) C:\Users\yousei takei\dir_django\hof>python manage.py migrate
Operations to perform:
  Apply all migrations: admin, app_halls, auth, contenttypes, sessions
Running migrations:
  Applying app_halls.0001_initial...Traceback (most recent call last):
  File "...\django\db\backends\utils.py", line 83, in _execute
    return self.cursor.execute(sql)
psycopg2.ProgrammingError: リレーション"app_halls_hallmodel"はすでに存在します


The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "manage.py", line 15, in <module>
    execute_from_command_line(sys.argv)
  File "...\django\core\management\__init__.py", line 381, in execute_from_command_line
    utility.execute()
  File "...\django\core\management\__init__.py", line 375, in execute
    self.fetch_command(subcommand).run_from_argv(self.argv)
  File "...\django\core\management\base.py", line 316, in run_from_argv
    self.execute(*args, **cmd_options)
  File "...\django\core\management\base.py", line 353, in execute
    output = self.handle(*args, **options)
  File "...\django\core\management\base.py", line 83, in wrapped
    res = handle_func(*args, **kwargs)
  File "...\django\core\management\commands\migrate.py", line 203, in handle
    fake_initial=fake_initial,
  File "...\django\db\migrations\executor.py", line 117, in migrate
    state = self._migrate_all_forwards(state, plan, full_plan, fake=fake, fake_initial=fake_initial)
  File "...\django\db\migrations\executor.py", line 147, in _migrate_all_forwards
    state = self.apply_migration(state, migration, fake=fake, fake_initial=fake_initial)
  File "...\django\db\migrations\executor.py", line 244, in apply_migration
    state = migration.apply(state, schema_editor)
  File "...\django\db\migrations\migration.py", line 124, in apply
    operation.database_forwards(self.app_label, schema_editor, old_state, project_state)
  File "...\django\db\migrations\operations\models.py", line 91, in database_forwards
    schema_editor.create_model(model)
  File "...\django\db\backends\base\schema.py", line 312, in create_model
    self.execute(sql, params or None)
  File "...\django\db\backends\base\schema.py", line 133, in execute
    cursor.execute(sql, params)
  File "...\django\db\backends\utils.py", line 100, in execute
    return super().execute(sql, params)
  File "...\django\db\backends\utils.py", line 68, in execute
    return self._execute_with_wrappers(sql, params, many=False, executor=self._execute)
  File "...\django\db\backends\utils.py", line 77, in _execute_with_wrappers
    return executor(sql, params, many, context)
  File "...\django\db\backends\utils.py", line 85, in _execute
    return self.cursor.execute(sql, params)
  File "...\django\db\utils.py", line 89, in __exit__
    raise dj_exc_value.with_traceback(traceback) from exc_value
  File "...\django\db\backends\utils.py", line 83, in _execute
    return self.cursor.execute(sql)
django.db.utils.ProgrammingError: リレーション"app_halls_hallmodel"はすでに存在します

python manage.py migrate --fakeで解決(?)

python manage.py runserver adminサイトにログイン 列app_halls_hallmodel.hall_user_idは存在しません

Traceback (most recent call last):
  File "C:\...\django\db\backends\utils.py", line 85, in _execute
    return self.cursor.execute(sql, params)
psycopg2.ProgrammingError: 列app_halls_hallmodel.hall_user_idは存在しません
LINE 1: ...s_hallmodel"."id", "app_halls_hallmodel"."title", "app_halls...
                                                             ^

The above exception was the direct cause of the following exception:(上記の例外は、次の例外の直接の原因です。)

Traceback (most recent call last):
  File "C:\...\django\core\handlers\exception.py", line 34, in inner
    response = get_response(request)
  File "C:\...\django\core\handlers\base.py", line 126, in _get_response
    response = self.process_exception_by_middleware(e, request)
  File "C:\...\django\core\handlers\base.py", line 124, in _get_response
    response = wrapped_callback(request, *callback_args, **callback_kwargs)
  File "C:\...\django\contrib\admin\options.py", line 604, in wrapper
    return self.admin_site.admin_view(view)(*args, **kwargs)
  File "C:\...\django\utils\decorators.py", line 142, in _wrapped_view
    response = view_func(request, *args, **kwargs)
  File "C:\...\django\views\decorators\cache.py", line 44, in _wrapped_view_func
    response = view_func(request, *args, **kwargs)
  File "C:\...\django\contrib\admin\sites.py", line 223, in inner
    return view(request, *args, **kwargs)
  File "C:\...\django\utils\decorators.py", line 45, in _wrapper
    return bound_method(*args, **kwargs)
  File "C:\...\django\utils\decorators.py", line 142, in _wrapped_view
    response = view_func(request, *args, **kwargs)
  File "C:\...\django\contrib\admin\options.py", line 1793, in changelist_view
    'selection_note': _('0 of %(cnt)s selected') % {'cnt': len(cl.result_list)},
  File "C:\...\django\db\models\query.py", line 250, in __len__
    self._fetch_all()
  File "C:\...\django\db\models\query.py", line 1186, in _fetch_all
    self._result_cache = list(self._iterable_class(self))
  File "C:\...\django\db\models\query.py", line 54, in __iter__
    results = compiler.execute_sql(chunked_fetch=self.chunked_fetch, chunk_size=self.chunk_size)
  File "C:\...\django\db\models\sql\compiler.py", line 1065, in execute_sql
    cursor.execute(sql, params)
  File "C:\...\django\db\backends\utils.py", line 100, in execute
    return super().execute(sql, params)
  File "C:\...\django\db\backends\utils.py", line 68, in execute
    return self._execute_with_wrappers(sql, params, many=False, executor=self._execute)
  File "C:\...\django\db\backends\utils.py", line 77, in _execute_with_wrappers
    return executor(sql, params, many, context)
  File "C:\...\django\db\backends\utils.py", line 85, in _execute
    return self.cursor.execute(sql, params)
  File "C:\...\django\db\utils.py", line 89, in __exit__
    raise dj_exc_value.with_traceback(traceback) from exc_value
  File "C:\...\django\db\backends\utils.py", line 85, in _execute
    return self.cursor.execute(sql, params)
django.db.utils.ProgrammingError: 列app_halls_hallmodel.hall_user_idは存在しません
LINE 1: ...s_hallmodel"."id", "app_halls_hallmodel"."title", "app_halls... 
  • userフィールドをコメントアウト
  • => HallModelのadminサイトは問題解決
  • => VideoModelのadminサイトは問題解決できず
  • => hallmodel のオブジェクトも削除できない

    VideoModelのadminサイト開く 列app_halls_videomodel.urlは存在しません

Internal Server Error: /admin/app_halls/videomodel/
Traceback (most recent call last):
  File "C:\...\django\db\backends\utils.py", line 85, in _execute
    return self.cursor.execute(sql, params)
psycopg2.ProgrammingError: 列app_halls_videomodel.urlは存在しません
LINE 1: ...videomodel"."id", "app_halls_videomodel"."title", "app_halls...
                                                             ^


The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "C:\...\django\core\handlers\exception.py", line 34, in inner
    response = get_response(request)
  File "C:\...\django\core\handlers\base.py", line 126, in _get_response
    response = self.process_exception_by_middleware(e, request)
  File "C:\...\django\core\handlers\base.py", line 124, in _get_response
    response = wrapped_callback(request, *callback_args, **callback_kwargs)
  File "C:\...\django\contrib\admin\options.py", line 604, in wrapper
    return self.admin_site.admin_view(view)(*args, **kwargs)
  File "C:\...\django\utils\decorators.py", line 142, in _wrapped_view
    response = view_func(request, *args, **kwargs)
  File "C:\...\django\views\decorators\cache.py", line 44, in _wrapped_view_func
    response = view_func(request, *args, **kwargs)
  File "C:\...\django\contrib\admin\sites.py", line 223, in inner
    return view(request, *args, **kwargs)
  File "C:\...\django\utils\decorators.py", line 45, in _wrapper
    return bound_method(*args, **kwargs)
  File "C:\...\django\utils\decorators.py", line 142, in _wrapped_view
    response = view_func(request, *args, **kwargs)
  File "C:\...\django\contrib\admin\options.py", line 1793, in changelist_view
    'selection_note': _('0 of %(cnt)s selected') % {'cnt': len(cl.result_list)},
  File "C:\...\django\db\models\query.py", line 250, in __len__
    self._fetch_all()
  File "C:\...\django\db\models\query.py", line 1186, in _fetch_all
    self._result_cache = list(self._iterable_class(self))
  File "C:\...\django\db\models\query.py", line 54, in __iter__
    results = compiler.execute_sql(chunked_fetch=self.chunked_fetch, chunk_size=self.chunk_size)
  File "C:\...\django\db\models\sql\compiler.py", line 1065, in execute_sql
    cursor.execute(sql, params)
  File "C:\...\django\db\backends\utils.py", line 100, in execute
    return super().execute(sql, params)
  File "C:\...\django\db\backends\utils.py", line 68, in execute
    return self._execute_with_wrappers(sql, params, many=False, executor=self._execute)
  File "C:\...\django\db\backends\utils.py", line 77, in _execute_with_wrappers
    return executor(sql, params, many, context)
  File "C:\...\django\db\backends\utils.py", line 85, in _execute
    return self.cursor.execute(sql, params)
  File "C:\...\django\db\utils.py", line 89, in __exit__
    raise dj_exc_value.with_traceback(traceback) from exc_value
  File "C:\...\django\db\backends\utils.py", line 85, in _execute
    return self.cursor.execute(sql, params)
django.db.utils.ProgrammingError: 列app_halls_videomodel.urlは存在しません
LINE 1: ...videomodel"."id", "app_halls_videomodel"."title", "app_halls...

~~~~~~ 以下参考 ~~~~~~

You are trying to add a non-nullable field 'user' to videomodel without a default;

1)今すぐ1回限りのデフォルトを指定します(この列にnull値を持つすべての既存の行に設定されます)。 2)終了し、models.pyにデフォルトを追加します。オプションを選択します

psycopg2.ProgrammingError: リレーション"app_halls_hallmodel"はすでに存在します

  • NOT NULL制約付きのカメラを追加, マイグレーションの実行
  • ull = Falseにしたい、それともnullを設定していないカメラを追加(や変更)する場合は、アップグレード時に初期値を指定
  • null = Falseとしても、default = ''のようにデフォルト値を指定していればマイグレーション時には聞かれません
  • makemigrationsを実行します。すると、以下のように選択肢
  • Select an option: 1 => >>> 'DUMMY'
  • マイグレーションが失敗するようになり、うんとすんともいない状態に =>
  • モデルとDBを同じ状態にする => フィールドを追加して失敗する場合そのフィールドをコメントアウト
  • マイグレーションを削除する => myapp/migrations/以下を全て削除
  • フェイク付きでマイグレーションを実行する
  • 既にモデルとDBは同じ状態になっているので、実際にはマイグレーションが走らせたくありません。
  • --fakeを指定 => ./manage.py migrate --fake

PostgreSQLエラー:リレーションは既に存在します

django.db.utils.ProgrammingError:リレーションは既に存在します

postgresql リレーション はすでに存在します

  • django.db.utils.ProgrammingError: column sites_site.airport_code does not exist LINE 1: ..._site"."sitemap_public_id", "sites_site"."state", "sites_sit...
  • まったく別のアプリでform.pyに含まれていたフォームへの呼び出しによってトレースされた.   * 新しいマイグレーションを作成しようとしていたモデルが呼び出される.
  • forms.pyからforms.pyをviews.pyに移動すると、問題が修正
  • マイグレーションファイルのmigrations.AlterUniqueTogether制約を手動で上げて 、
  • フィールドを削除しようとする前にdjangoが最初に制約を削除する
  • マイグレーションファイルのmigrations.AlterUniqueTogether制約を手動で上げて 、フィールドを削除しようとする前にdjangoが最初に制約を削除するようにしたことです。

psycopg2.ProgrammingError: 列app_halls_hallmodel.hall_user_idは存在しません

Django / Postgresの移行に失敗した“ django.db.utils.ProgrammingError:relation” django_site“存在しません”

  • django.db.utils.ProgrammingError: relation "django_site" does not exist
  • django_siteが存在しないことを訴えています。
  • ./manage.py dbshel​​lはデータベースに正常に入ります。
  • ./manage.py flush => relation "django_site" does not exist
  • テーブル作成時にアプリがdjango_siteに依存していることは考慮されていません。
  • django.contrib.sitesへの依存がエラーの原因となっているアプリの移行の作成に関する問題を簡単に回避
  • python manage.py makemigrations allauth

    Djangoの初回マイグレーション時に relation "auth_user" does not exist というエラーが発生する場合

  • $ python manage.py migrate しようとすると、以下のようなエラーが発生した。
  • django.db.utils.ProgrammingError: relation "auth_user" does not exist
  • django.contrib.auth.models.Userへのリレーションを張っているのに、Userのテーブルがまだ作られていないことがマズい
  • 先にauthのマイグレーションを行うことで、この問題を回避できます。
  • python manage.py migrate auth => $ python manage.py migrate

    "ProgrammingError:" music_album "というリレーションの列" genre_id "は存在しません"列が存在する

  • 南の移行で genre 属性を追加しました。
  • pg_adminを使用して music_album テーブルの genre_id という列を見ることができます。
  • genre = models.ForeignKey(Genre, null=True, blank=True)
  • LINE 1: ..._id", "title", "release_date", "right_holder_id", "genre_id"... . ^
  • 生成されるSQL: INSERT INTO "music_album" ("culturaldocument_ptr_id", "title", "release_date",
  • "right_holder_id", "genre_id") VALUES (%s, %s, %s, %s, %s)
  • このエラーがユニットテストを実行している。私が移行したとき、
  • 私は通常のデータベースにマイグレーションを適用しましたが、単体テストは別のデータベースを使用します。
  • テストテーブルは移行前に存在していたスキームを使用。私はそれらを削除し、py.testにそれらを再作成するように強制
  • nullにすることができますが、genre_idは 'music_album'には存在しません。
  • クエリには含まれていません。ちょうど私が有効なジャンルでテストした場合、同じエラーが発生しました。
  • genre_id はモデルの定義によってnullになります
  • "ProgrammingError:" music_album "というリレーションの列" genre_id "は存在しません"列が存在する

    Djangoに「column」というcontent_type_idが存在しないというエラーが表示されるのはなぜですか?

  • content_type = models.ForeignKey(ContentType, on_delete=models.CASCADE) 
    
  • content_object = GenericForeignKey('content_type', 'object_id') 
    
  • "アプリケーションの列" content_type_id " lication_comment "は存在しません LINE 1:。INSERT INTO "
  • 編集: "ショーのpython manage.pyのshowmigrationsの出力"
  • 私はそれらをリセットするためにすべての私のデータベースと以前の移行を削除しようとしました
  • 「コメントが含まれており、アプリの任意の移行ファイル」問題)を解決しません
  • 問題はモデルではなくデータベースにあります
  • postgreですべてのテーブルを落とし、マイグレーションをやり直してすべてが機能
  • すべてのこれらの移行ファイルを削除してはいけませんでした
  • コメントした後、私はmakemigrationsを実行して問題なくmigrate

  • Djangoに「column」というcontent_type_idが存在しないというエラーが表示されるのはなぜですか?

python-3.x postgresql error - Django移行エラー:列が存在しません

  • settings.pyのINSTALLED_APPSからdjangoデバッグツールバーコメントアウトすることで解決
  • 私がmakemigrationsを実行したときに私はエラーが発生しました:
  • django.db.utils.ProgrammingError: column sites_site.airport_code does not exist LINE 1: ..._site"."sitemap_public_id", "sites_site"."state", "sites_sit...
  • 移行中に列を作成しようとしているときに列が明らかに存在しない
  • 手動で移行ファイルを作成する、またはデータベースを破棄して再構築するソリューションがあります。
  • 原因:移行ファイルを削除し、最後の変更のために移行を実行する前に、最初の移行ファイル0001に置き換えました
  • そのアプリケーションの移行に関連するテーブルを削除
  • そのアプリケーションの移行を担当する行を、移行が記録されているテーブルdjango_migrationsから削除
  • sudo -i -u postgres
  • psql -d database_name
  • \dt
  • DROP TABLE tablename ;
  • DELETE FROM django_migrations WHERE app='your_app';
  • python-3.x postgresql error - Django移行エラー:列が存在しません - CODE Q&A 問題解決

postgresql 列は存在しません

The above exception (列app_halls_videomodel.urlは存在しません LINE 1: ...videomodel"."id", "app_halls_videomodel"."title", "app_halls... ^ ) was the direct cause of the following exception:

Djangoが例外値「no such table:polls_question_page」でクラッシュする

  • page = models.ManyToManyField(Page)
  • Exception Type: OperationalError at /admin/polls/question/4/change/
  • Exception Value: no such table: polls_question_page
  • python manage.py makemigrations => System check identified some issues:
  • djangoモデルとデータベースが同期していないことを意味します。移行を実行しなければなりません。
  • => Exception Value: no such table: polls_question_page
  • どのマイグレーションが適用されたと思われるかのリストを取得する
  • => manage.py showmigrations
  • アプリの「投票」の移行元を読み、それが適用されていないものを見つけます。その後、移行前にロールバック
  • => manage.py migrate polls 0004
  • マイグレーションを再実行します。
  • => manage.py migrate polls
  • そうでない場合は、空のデータベースからやり直すことをお勧めします。
  • データベースを完全にリセットする最も簡単な方法は、おそらくreset_dbパッケージdjango-extensionsからのコマンド
  • reset_db - データベース(現在はsqlite3、mysql、postgres)をリセット
  • DROP DATABASE」と「CREATE DATABASE」を使用

  • Django / Postgresの移行に失敗した“ django.db.utils.ProgrammingError:relation” django_site“存在しません” - コードログ